Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## avrora.core.isdl
Class Architecture

    java.lang.Object
      avrora.core.isdl.Architecture

public class Architecture
extends java.lang.Object

The `Architecture` class represents a collection of instructions, encodings, operands, and subroutines that describe an instruction set architecture.

Nested Class Summary
`static interface` | `Architecture.EncodingVisitor`
`static interface` | `Architecture.InstrVisitor`
`static interface` | `Architecture.OperandVisitor`
`class` | `Architecture.PrettyPrinter`
`static interface` | `Architecture.SubroutineVisitor`
`static interface` | `Architecture.Visitor` The `Visitor` class represents a visitor over the elements of the architecture description.

Field Summary
`Token` | `name`

Constructor Summary
`Architecture(Token n)`

Method Summary
`void` | `accept(Architecture.EncodingVisitor v)`
`void` | `accept(Architecture.InstrVisitor v)`
`void` | `accept(Architecture.OperandVisitor v)`
`void` | `accept(Architecture.SubroutineVisitor v)`
`void` | `accept(Architecture.Visitor v)` The `accept()` method implements part of the visitor pattern that allows a visitor to visit each part of the architecture description.
`void` | `addEncoding(EncodingDecl d)`
`void` | `addInstruction(InstrDecl i)`
`void` | `addOperand(OperandDecl d)`
`void` | `addSubroutine(SubroutineDecl d)`
`java.util.Iterator` | `getEncodingIterator()`
`java.util.Iterator` | `getInstrIterator()`
`InstrDecl` | `getInstruction(java.lang.String name)`
`OperandDecl` | `getOperandDecl(java.lang.String name)`
`SubroutineDecl` | `getSubroutine(java.lang.String name)`
`java.util.Iterator` | `getSubroutineIterator()`
`void` | `process()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### name

    public final Token name

Constructor Detail

### Architecture

    public Architecture(Token n)

Method Detail

### process

    public void process()

### getInstrIterator

    public java.util.Iterator getInstrIterator()

### getEncodingIterator

    public java.util.Iterator getEncodingIterator()

### getSubroutineIterator

    public java.util.Iterator getSubroutineIterator()

### addSubroutine

    public void addSubroutine(SubroutineDecl d)

### addInstruction

    public void addInstruction(InstrDecl i)

### addOperand

    public void addOperand(OperandDecl d)

### addEncoding

    public void addEncoding(EncodingDecl d)

### accept

    public void accept(Architecture.Visitor v)

  The `accept()` method implements part of the visitor pattern that allows a visitor to visit each part of the architecture description.

  Parameters:
    `v` - the visitor to accept

### accept

    public void accept(Architecture.OperandVisitor v)

### accept

    public void accept(Architecture.EncodingVisitor v)

### accept

    public void accept(Architecture.SubroutineVisitor v)

### accept

    public void accept(Architecture.InstrVisitor v)

### getInstruction

    public InstrDecl getInstruction(java.lang.String name)

### getSubroutine

    public SubroutineDecl getSubroutine(java.lang.String name)

### getOperandDecl

    public OperandDecl getOperandDecl(java.lang.String name)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD